// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

/**
 * Provides a label over the input field.
 */
define([], function() {
jQuery.fn.labelOver = function(overClass) {
  return this.each(function(){
    var label = jQuery(this);
    var f = label.attr('for');
    if (f) {
      var input = jQuery('#' + f);

      var hide = function() {
        label.css({ textIndent: -10000 });
      };
      this.hide = hide;

      var show = function() {
        if (input.val() === '') {
          label.css({
            textIndent: 2,
            cursor: 'text'
          });
        }
      };
      this.show = show;

      this.check = function() {
        if (input.val() === '') {
          show();
        } else {
          hide();
        }
      };

      // handlers
      input.change(this.check);
      input.focus(this.hide);
      input.blur(this.show);
      label.addClass(overClass).click(function(){
        input.focus();
      });

      if (input.val() !== '' || input.is(':focus')) {
        hide();
      }
    }
  });
};
});
